"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AsyncAdapter: () => import_node2.AsyncAdapter,
  FastifySteno: () => FastifySteno,
  SyncAdapter: () => import_node2.SyncAdapter,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_node2 = require("@stenodb/node");
var import_fastify_plugin = __toESM(require("fastify-plugin"));

// src/plugin.ts
var import_node = require("@stenodb/node");
var import_class_validator_jsonschema = require("class-validator-jsonschema");
var _fastify, _options, _provider, _databases;
var _StenoPlugin = class {
  constructor(fastify, options) {
    __privateAdd(this, _fastify, void 0);
    __privateAdd(this, _options, void 0);
    __privateAdd(this, _provider, void 0);
    __privateAdd(this, _databases, void 0);
    __privateSet(this, _fastify, fastify);
    __privateSet(this, _options, options);
    __privateSet(this, _provider, new import_node.NodeProvider(options));
    __privateSet(this, _databases, /* @__PURE__ */ new Map());
    __privateGet(this, _fastify).decorate("steno", { get: this.getDatabase.bind(this) });
  }
  static async createInstance(fastify, options, done) {
    const db = new _StenoPlugin(fastify, options);
    await db.registerDatabases();
    done();
    return db;
  }
  async registerDatabases() {
    this.registerEntities();
    for (const adapter of __privateGet(this, _options).adapters) {
      const db = await __privateGet(this, _provider).create(adapter);
      if (adapter instanceof import_node.SyncAdapter) {
        db.read();
      } else if (adapter instanceof import_node.AsyncAdapter) {
        await db.read();
      } else {
        throw new TypeError("Invalid adapter");
      }
      this.addSchema(adapter.entity);
      __privateGet(this, _databases).set(adapter.fileName, db);
    }
  }
  registerEntities() {
    if (!__privateGet(this, _options).entities)
      return;
    for (const entity of __privateGet(this, _options).entities) {
      this.addSchema(entity);
    }
  }
  addSchema(entity) {
    if (__privateGet(this, _fastify).getSchema(entity.name))
      return;
    const schema = (0, import_class_validator_jsonschema.targetConstructorToSchema)(
      entity,
      __privateGet(this, _options).entityOptions
    );
    if (!schema.properties)
      return;
    __privateGet(this, _fastify).addSchema({ ...schema, $id: entity.name });
  }
  getDatabase(name) {
    return __privateGet(this, _databases).get(name);
  }
};
var StenoPlugin = _StenoPlugin;
_fastify = new WeakMap();
_options = new WeakMap();
_provider = new WeakMap();
_databases = new WeakMap();

// src/index.ts
var FastifySteno = (0, import_fastify_plugin.default)(StenoPlugin.createInstance, {
  name: "@stenodb/fastify",
  fastify: "4.x"
});
var src_default = StenoPlugin.createInstance;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AsyncAdapter,
  FastifySteno,
  SyncAdapter
});
